"use strict";

// Note canvas.width et canvas.height
// It is better to specify your canvas dimensions by setting the width and
// height attributes directly on the <canvas> elements, either directly in the
// HTML or by using JavaScript.

// -- État du pingouin
let tux = {
    x: 50, y: 280, // position (x, y)
    width: 45, height: 65, //
    num: 0, // compteur d'animation
    direction: "right", // direction
    speed: 2, // vitesse
    draw: function () {
    }
};
// -- État courant des cubes de glace en jeu
let cubes = {
    blocks: [],
    speed: 2,
    spawnRate: 500
}

// -- État d'un bloc de glace
// let ice {
//     x: number, y: number, // position (x, y)
//     width: 
// }

// -- Ressources graphiques
let frames = {
    left: [], right: [], // pingouin
    bg: new Image(), // arriere-plan
    ice: new Image() // bloc de glace
}

window.onload = function() {
    // -- Initialisation
    // initialisation du contexte graphique 2D
    let canvas = document.getElementById("cadre");
    let c2d = canvas.getContext('2d');
    // chargement des ressources graphiques
    for (let i = 0; i < 6; ++i) {
        frames.left[i] = new Image();
        frames.right[i] = new Image();
        frames.left[i].src = "images/largetux-walk-left-" + i + ".png";
        frames.right[i].src = "images/largetux-walk-right-" + i + ".png";
    }
    frames.bg.src = "images/forest.jpg";
    frames.ice.src = "images/icecube.png";


    // -- Dessin
    function draw() {
        // Dessin de l'arriere-plan avec des rectangles
        c2d.fillStyle="#A0F0FF";
        c2d.fillRect(0, 0, canvas.width, canvas.height * 0.7);
        c2d.fillStyle="white";
        c2d.fillRect(0, canvas.height * 0.7, canvas.width, canvas.height * 0.3);
        // Dessin de l'arriere-plan avec une image
        c2d.drawImage(frames.bg, 0, 0, canvas.width, canvas.height);
        // Note: inutile d'effacer tout l'écran car l'arriere-plan couvre tout
        //c2d.clearRect(0, 0, canvas.width, canvas.height);

        // Dessin du pingouin
        let img = frames[tux.direction][tux.num % 6];
        c2d.drawImage(img, tux.x, tux.y);

        for (let i = 0; i < cubes.blocks.length; ++i) {
            let ice = cubes.blocks[i];
            c2d.drawImage(frames.ice, ice.x, ice.y, ice.width, ice.height);
        }
    }


    // -- Mise à jour de l'état du pingouin
    var isLeft = false;
    var isRight = false;
    function update() {
        if (tux.speed <= 0) return;
        if (isLeft && tux.x >= 0) {
            tux.direction = 'left';
            tux.x -= tux.speed;
            tux.num += 1;
        } else if (isRight && tux.x + tux.width < canvas.width) {
            tux.direction = 'right';
            tux.x += tux.speed;
            tux.num += 1;
        }

        for (let i = 0; i < cubes.blocks.length; ++i) {
            let cube = cubes.blocks[i];
            if (cube.y < canvas.height) {
                cube.y += cubes.speed;
            } else {
                cubes.blocks.splice(i, 1);
            }
        }
    }


    // -- Animation
    function animate() {
        update();
        draw();
    }
    setInterval(animate, 17);


    // -- Apparition des blocs de glace
    function spawn() {
        let x = 0; // TODO: random
        let ice = {
            x: Math.random() * canvas.width, y: 10,
            width: 32, height: 32
        };
        cubes.blocks.push(ice);
        console.log(cubes.blocks.length);
    }
    setInterval(spawn, cubes.spawnRate);

    function stop() {
        tux.speed = 0;
    }
    document.getElementById("stopButton")
        .addEventListener('click', stop, false);

    function fast() {
        tux.speed += 2;
    }
    document.getElementById("speedButton")
        .addEventListener('click', fast, false);

    // -- Gestion clavier
    function down(e) {
        if (e.keyCode == 37) { isLeft = true; }
        if (e.keyCode == 39) { isRight = true; }
    }
    function up(e) {
        if (e.keyCode == 37) { isLeft = false; }
        if (e.keyCode == 39) { isRight = false; }
    }
    window.addEventListener('keydown', down, false);
    window.addEventListener('keyup', up, false);

}
